︠ac6b45fe-fe3c-4266-ac08-3c878606b019i︠
%html
<h1>Varios m&eacute;todos para calcular PI</h1>
<h2>Serie arm&oacute;nica</h2>
<p>Cortes&iacute;a de <a href="http://gaussianos.com/el-desarrollo-mas-bello-de-pi-como-suma-infinita/">Gaussianos</a></p>

︡4f995dd1-c6ba-41a1-b914-268b63018ffb︡{"html": "<h1>Varios m&eacute;todos para calcular PI</h1>\n<h2>Serie arm&oacute;nica</h2>\n<p>Cortes&iacute;a de <a href=\"http://gaussianos.com/el-desarrollo-mas-bello-de-pi-como-suma-infinita/\">Gaussianos</a></p>"}︡
︠eec8f27b-13d3-4d0b-ba84-914becb83fa5︠
def forma4m1(n):
        'da +1 ó -1 según un número sea de la forma 4m+1 o 4m-1'
	if (n+1)%4 == 0:
		return +1
	if (n-1)%4 == 0:
		return -1
	return +1
︡dec0a177-bc4a-4877-b69f-381b8a58e4ee︡︡
︠d7d3330b-1277-4503-83fe-7398b394fcf5︠
# Aquí guardaremos a lista de valores de pi por cada término
api=[]
# Los dos primeros términos son 1 y 1/2
api.append([1,1])
api.append([2,1.5])
mipi=1+0.5	

terminos=10000

for i in range(terminos)[3:]:
	fa=list(factor(i))
	if is_prime(i):
		signo=forma4m1(i)
	else:
		signo=1
		for f in fa:
                        for f2 in range(f[1]):
			    signo*=forma4m1(f[0])
	mipi+=signo*1./i
	api.append([i,mipi])

print mipi
list_plot(api, plotjoined=True)
︡90a53c63-10fd-4300-978b-88fba9ff5718︡{"stdout": "3.11042957448254"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠993e03a7-5de1-46f2-886f-2dfded4b2de6i︠
%html
<h2>Montecarlo</h2>
<h3>2 dimensiones</h3>

︡d91f6e2d-a055-4daf-aacf-7720fd64091f︡{"html": "<h2>Montecarlo</h2>\n<h3>2 dimensiones</h3>"}︡
︠3e3ff8d8-be29-4e13-85dc-d57ef4890cad︠
npuntos=10000
dentro=0.
fuera=0.
api=[]
for i in range(npuntos):
    x=random()
    y=random()
    r=x**2+y**2
    if r < 1:
        dentro+=1
    else:
        fuera+=1
    pi=4*dentro/(fuera+dentro)
    api.append(pi)
print float(pi)
list_plot(api,plotjoined=True)
︡55760a8f-b904-4602-beb9-cc35f927c0ef︡{"stdout": "3.166"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠3234a82b-b4b5-4eb2-ab6e-87d51f4e39a2i︠
%html
<h3>3 dimensiones</h3>

︡cc6566a5-940c-43f4-ac0a-0742e1910b3a︡{"html": "<h3>3 dimensiones</h3>"}︡
︠c2ab8437-b5a9-4241-9750-cf36a7bf50e0︠
npuntos=10000
dentro=0.
fuera=0.
api=[]
for i in range(npuntos):
    x=random()
    y=random()
    z=random()
    r=x**2+y**2+z**2
    if r < 1:
        dentro+=1
    else:
        fuera+=1
    mipi=6*dentro/(fuera+dentro)
    api.append(mipi)
print mipi
list_plot(api,plotjoined=True)
︡2ba78d9a-0b21-436e-a8f6-d3da9db9ddd6︡{"stdout": "3.11220000000000"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠97b83711-2b5a-4556-b110-1fc1f141df16i︠
%html
<h2>Pseudo-montecarlo (grid)</h2>

︡2b69051c-d039-4afd-85c3-ad6de990fee4︡{"html": "<h2>Pseudo-montecarlo (grid)</h2>"}︡
︠4b670940-9317-4d19-9064-ce3153e7d6b9︠
npuntos=10000
pts=sqrt(npuntos)
dentro=0.
fuera=0.
api=[]
for x in range(pts):
    for y in range(pts):
        r=(x/pts)**2+(y/pts)**2
        if r < 1:
            dentro+=1
        else:
            fuera+=1
    mipi=4*dentro/(fuera+dentro)
    api.append(mipi)
print float(mipi)
list_plot(api,plotjoined=True)
︡63e51c53-beb3-404b-a656-90feaa306877︡{"stdout": "3.1796"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
